import java.io.*;
import java.util.*;


import JavaGroups.*;


public class McastTest {
    Channel        channel;
    RpcDispatcher  dispatcher;
    String         groupname="McastTestGroup";
    String         props="UDP:PING:FD:DISCARD(trace=true;down=0.3):NAKACK(retransmit_timeout=1000):"+
	                 "UNICAST(trace=true):FRAG:FLUSH:GMS:VIEW_ENFORCER:QUEUE";



    public void Foo(int num) {
	System.out.println("Foo(" + num + ") was called");
	Util.Sleep(1500);
	System.out.println("Foo(): returning");
    }


    public void Start() throws Exception {
	int     rand;

	channel=new JChannel(props);
	dispatcher=new RpcDispatcher(channel, null, null, this);
	channel.Connect(groupname);


	while(true) {
	    rand=(int)(Math.random() * 100);
	    System.out.println("\n\nCalling Foo(" + rand + "):");
	    channel.Down(new Event(Event.SWITCH_NAK_ACK));
	    dispatcher.CallRemoteMethods(null, "Foo", new Integer(rand), GroupRequest.GET_ALL, 0);
	    System.out.println("DONE");
	    Util.Sleep(2000);
	}
    }




    public static void main(String[] args) {
	try {
	    new McastTest().Start();
	}
	catch(Exception e) {
	    System.err.println(e);
	}
    }
}
