
import java.io.*;
import java.util.*;
import JavaGroups.*;


public class MessageDispatcherTest implements RequestHandler {
    Channel            channel;
    MessageDispatcher  disp;
    RspList            rsp_list;



    public void Start() throws Exception {
	channel=new JChannel();
	disp=new MessageDispatcher(channel, null, null, this);
	channel.Connect("MessageDispatcherTestGroup");

	for(int i=0; i < 10; i++) {
	    Util.Sleep(1000);
	    rsp_list=disp.CastMessage(null, 
				      new Message(null, null, new String("Number #" + i).getBytes()),
				      GroupRequest.GET_ALL, 0);
	    System.out.println("Responses: " +rsp_list);
	}
	channel.Close();
	disp.Stop();
    }



    public Object Handle(Message msg) {
	System.out.println("Handle(): " + msg);
	return new String("Success !");
    }



    public static void main(String[] args) {
	try {
	    new MessageDispatcherTest().Start();
	}
	catch(Exception e) {
	    System.err.println(e);
	}
    }
}
