package JavaGroups;

import java.util.*;


public interface MembershipListener {
    

    /**
       Called by JavaGroups to notify the target object of a change of membership.
       <b>No long running actions should be done in this callback in the case of Ensemble,
       as this would block Ensemble.</b> If some long running action needs to be performed,
       it should be done in a separate thread (cf. <code>../Tests/QuoteServer.java</code>).
    */
    void ViewAccepted(View new_view);


    /** Called when a member is suspected */
    void Suspect(Object suspected_mbr);


    /** Block sending and receiving of messages until ViewAccepted is called */
    void Block();

}
